unit sSharedCOM;
(************************************************************************
sStyle components package 
Copyright (c) 2002 Serge Goncharov. All rights reserved.
                            Ukraine, Odessa
                            http://www.geocities.com/sstylish2002/
                            Serge@HyBce.com
 Version:	1.2, 24-02-2002
*************************************************************************)

interface

uses Windows, Messages, SysUtils, Classes, db, ComObj, StrUtils, forms, Controls, dbgrids,
     sUtils;

function DataSetToExcel(var Srv, WorkBook: variant; DataSet: TDataSet; FirstRow,FirstCol:integer; TableName:string; ShowAsRowsFill, ShowBorders, OEM2ANSI, ServerAssigned, WorkBookAssigned:boolean):boolean;
function GroupDatasetInExcel(DataSet:TDataSet; FirstRow,FirstCol:integer; GroupFieldName:string;
           ShowAsRowsFill, CalcSummary:boolean; CountRowsInPage, ColumnWidth:integer):boolean;
procedure ValueFromFieldToCell(Field:TField; Cell:variant; Typed, OEM2ANSI:boolean); //    Field   Cell
procedure FieldCaptionsToHeader(DataSet:TDataset; var FirstRow,FirstCol:integer; Sheet: variant; ShowBorders:boolean);
function CreateNewTemplate(Grid : TCustomDBGrid) : variant;
//function PageToExcel(vExcel:variant; SheetName:string; x,y:integer; DataSet:TDataSet);

implementation

function CreateNewTemplate(Grid : TCustomDBGrid) : variant;
var
  vExcel, vSheet, vWorkBook : variant;
  c, Col, Rows, r, FCol, FirstCol, FirstRow : integer;
  TempWord, CurLabelText:string;
  MyRange: variant;
  ShowBorders : boolean;
begin
try
  vExcel:=UnAssigned;
  vExcel:=CreateOleObject('Excel.Application');
  vExcel.DisplayAlerts := false;
  vExcel.Interactive := False;
  vWorkBook := vExcel.WorkBooks.Add;

  vExcel.Visible := True;

  vSheet := vWorkBook.WorkSheets[1];
  vSheet.Name := '1';
  vSheet.Cells.Font.Size := 8;
  FirstCol := 2;
  FirstRow := 2;
  ShowBorders := True;

  Rows := 0;

  //     
  for c := 0 to Grid.FieldCount - 1 do begin
    Rows := Maxi(Rows, WordCount(Grid.Fields[c].DisplayLabel, ['|']));
    //    
//    vSheet.Columns[c + FirstCol].ColumnWidth := Grid.Fields[c].Width div Grid.Font.Size + 2;
  end;

  //  
  for r := 1 to Rows do begin
    //   
    Col := FirstCol;
    FCol := Col;
    for c := 0 to Grid.FieldCount - 1 do begin
       //   
       if ShowBorders then begin
         vSheet.Cells[FirstRow, Col].Borders.LineStyle:=1;
         vSheet.Cells[FirstRow, Col].Borders.Weight:=3;
         vSheet.Rows[FirstRow].Font.Bold:=true;
       end;

       //     
       vSheet.Cells[FirstRow, Col].HorizontalAlignment := 3;
       vSheet.Cells[FirstRow, Col].VerticalAlignment := 1;
       vSheet.Cells[FirstRow, Col].WrapText := True;

       //    
       CurLabelText := ExtractWord(r, Grid.Fields[c].DisplayLabel, ['|']);

       //         (!)  
       if (FCol = Col) or (CurLabelText = '') then begin //, then we writing text orderly
         // ,  ,    
         if (CurLabelText = '') and (r > 1) then begin
           //      
           TempWord := vSheet.Cells[FirstRow-1, Col];
           vSheet.Application.Union(vSheet.Cells[FirstRow-1, Col], vSheet.Cells[FirstRow, Col]) := TempWord;
         end
         else begin
           //  
//           vSheet.Cells[FirstRow, Col] := ExtractWord(r, Grid.Columns[c].Field.DisplayLabel, ['|']);
         end;
       end
       else begin //     
         MyRange := vSheet.Application.Union(vSheet.Cells[FirstRow, FCol], vSheet.Cells[FirstRow, Col]);
         MyRange.Value := CurLabelText;
       end;
       // ,      
       FCol := Col + 1;

{
       case Grid.Columns[c].Field.DataType of
       ftFloat, ftInteger, ftSmallInt, ftCurrency: begin
         vSheet.Columns[Col].NumberFormat:=TFloatField(Grid.Columns[c].Field).DisplayFormat;
       end;
       end;
}
       inc(Col);
     end;
     inc(FirstRow);
  end;
  // 
  for c := 0 to Grid.FieldCount - 1 do begin
    vSheet.Cells[FirstRow, c + FirstCol] := '=' + Grid.DataSource.DataSet.Name + '_' + Grid.Fields[c].FieldName;
  end;
  //    Range   FirstRange
  vSheet.Range['A' + IntToStr(FirstRow), 'Z' + IntToStr(FirstRow+1)].Name := 'FirstRange';

  if not vExcel.Visible then vExcel.Visible:=True;
  vExcel.Interactive := True;
  vExcel:=UnAssigned;
  Result := vSheet;
except
end;
end;

function DataSetToExcel(var Srv, WorkBook: variant; DataSet: TDataSet; FirstRow,FirstCol:integer; TableName:string; ShowAsRowsFill, ShowBorders, OEM2ANSI, ServerAssigned, WorkBookAssigned:boolean):boolean;
var
   vExcel, vSheet, vWorkBook:variant;
   Row, Col, c:integer;
   s:string;
begin
   try
     if DataSet.Active then begin
       vExcel:=UnAssigned;

       if ServerAssigned then begin
         vExcel:= Srv;
       end
       else begin
         vExcel:=CreateOleObject('Excel.Application');
         vExcel.DisplayAlerts:=false;
         vExcel.Visible:=ShowAsRowsFill;
         Srv:= vExcel;
       end;

       if WorkBookAssigned then begin
         vWorkBook:=WorkBook;
       end
       else begin
         vWorkBook:=vExcel.WorkBooks.Add;
         WorkBook:= vWorkBook;
       end;


       if WorkBookAssigned then begin
         vSheet:=vWorkBook.Sheets.Add;
       end
       else begin
         vSheet:=vWorkBook.WorkSheets[1];
       end;
       vSheet.Name:=TableName;
       DataSet.First;
       Row:=FirstRow;
       Col:=FirstCol;
       FieldCaptionsToHeader(DataSet, Row, Col, vSheet, ShowBorders);
       Inc(Row);

       while not DataSet.EOF do begin
         Col:=FirstCol;
         for c:=0 to DataSet.FieldCount-1 do begin
           if DataSet.Fields[c].Visible then begin
             if ShowBorders then begin
               vSheet.Cells[Row,Col].Borders.LineStyle:=1;
             end;
             ValueFromFieldToCell(DataSet.Fields[c], vSheet.Cells[Row,Col], True, OEM2ANSI);
             inc(Col);
           end;
         end;
         vSheet.Rows[Row].Select;
         Inc(Row);
         DataSet.Next;
       end;
       vSheet.Cells.Columns.AutoFit;
       if (not ServerAssigned) and (not vExcel.Visible) then begin
         vExcel.Visible:=True;
         vExcel:=UnAssigned;
       end;
       Result:= True;
     end
     else begin
       Result := False;
       Exit;
     end;
   except
     ShowError('   OLE-. ,     Excel97  .');
   end;
end;

procedure FieldCaptionsToHeader(DataSet:TDataset; var FirstRow,FirstCol:integer; Sheet: variant; ShowBorders:boolean);
var
   c, Col, Rows, r, FCol:integer;
   TempWord:string;
   MyRange: variant;
begin
       Col:=FirstCol;
       Rows:=0;
       for c:=0 to DataSet.FieldCount-1 do begin
         if DataSet.Fields[c].Visible then begin
           if StrUtils.WordCount(DataSet.Fields[c].DisplayLabel, ['|'])>Rows then Rows:=StrUtils.WordCount(DataSet.Fields[c].DisplayLabel, ['|']);
           inc(Col);
         end;
       end;
       //  
       for r:=1 to Rows do begin
         Col:=FirstCol;
         FCol:=Col;
         for c:=0 to DataSet.FieldCount-1 do begin
           if DataSet.Fields[c].Visible then begin
             // 
             if ShowBorders then begin
               Sheet.Cells[FirstRow,Col].Borders.LineStyle:=1;
               Sheet.Cells[FirstRow,Col].Borders.Weight:=3;
               Sheet.Rows[FirstRow].Font.Bold:=true;
             end;
             Sheet.Columns[Col].Columnwidth:=DataSet.Fields[c].DisplayWidth;
             Sheet.Cells[FirstRow, Col].HorizontalAlignment := 3;

             //          , 
             if (c<(DataSet.FieldCount-1)) and
             (StrUtils.ExtractWord(r,DataSet.Fields[c].DisplayLabel, ['|'])<>StrUtils.ExtractWord(r,DataSet.Fields[c+1].DisplayLabel, ['|'])) then begin
               //          
               if (FCol=Col) or (StrUtils.ExtractWord(r,DataSet.Fields[c].DisplayLabel, ['|'])='') then begin //, then we writing text orderly
                 if (StrUtils.ExtractWord(r,DataSet.Fields[c].DisplayLabel, ['|'])='') and (r>1) then begin
                   TempWord:=Sheet.Cells[FirstRow-1, Col];
//                   Sheet.Application.Union(Sheet.Cells[FirstRow-1, Col], Sheet.Cells[FirstRow, Col]):=TempWord;
                 end
                 else begin
                   Sheet.Cells[FirstRow, Col]:=StrUtils.ExtractWord(r,DataSet.Fields[c].DisplayLabel, ['|']);
                 end;
               end
               else begin             // else we need union this
                 MyRange:=Sheet.Application.Union(Sheet.Cells[FirstRow, FCol], Sheet.Cells[FirstRow, Col]);
                 MyRange.Value:=StrUtils.ExtractWord(r,DataSet.Fields[c].DisplayLabel, ['|']);
               end;
               FCol:=Col+1;
             end
             else begin // otherwise we nothing to do, waiting for end of similar captions
               if (StrUtils.ExtractWord(r,DataSet.Fields[c].DisplayLabel, ['|'])='') and (r>1) then begin
                 TempWord:=Sheet.Cells[FirstRow-1, Col];
//                 Sheet.Application.Union(Sheet.Cells[FirstRow-1, Col], Sheet.Cells[FirstRow, Col]):=TempWord+'!';
//                 Sheet.Application.Union(Sheet.Cells[FirstRow-1, Col], Sheet.Cells[FirstRow, Col]).VerticalAlignment := 3;
               end
               else begin
                 Sheet.Application.Union(Sheet.Cells[FirstRow, Col], Sheet.Cells[FirstRow, Col+1]):='';
               end
//               if c=(DataSet.FieldCount-1) then begin
//                 Sheet.Cells[FirstRow, Col]:=StrUtils.ExtractWord(r,DataSet.Fields[c].DisplayLabel, ['|']);
//               end;
             end;

             case DataSet.Fields[c].DataType of
             ftFloat, ftInteger, ftSmallInt, ftCurrency: begin
               Sheet.Columns[Col].NumberFormat:=TFloatField(DataSet.Fields[c]).DisplayFormat;
             end;
             end;
             inc(Col);
           end;
         end;
       inc(FirstRow);
       end;
//       inc(FirstRow, Rows-1);
end;

procedure ValueFromFieldToCell(Field:TField; Cell:variant; Typed, OEM2ANSI: boolean);
begin
     if Typed then begin

       //  
       case Field.DataType of
       ftString: begin
         if OEM2ANSI then begin
           Cell.Value:=''''+StrUtils.OemToAnsiStr(Field.asString);
         end
         else begin
           Cell.Value:=''''+Field.asString;
         end;
       end
       else begin
         Cell.Value:=Field.asString;
       end;
       end;

       // 
       case Field.Alignment of
       taCenter: begin
         Cell.HorizontalAlignment := 3;
       end;
       taLeftJustify: begin
         Cell.HorizontalAlignment := 2;
       end;
       taRightJustify: begin
         Cell.HorizontalAlignment := 4;
       end
       end;
     end
     else begin // As is
         if OEM2ANSI then begin
           Cell.Value:=''''+StrUtils.OemToAnsiStr(Field.asString);
         end
         else begin
           Cell.Value:=''''+Field.asString;
         end;
     end;
end;

function GroupDatasetInExcel(DataSet:TDataSet; FirstRow,FirstCol:integer; GroupFieldName:string; ShowAsRowsFill, CalcSummary:boolean; CountRowsInPage, ColumnWidth:integer):boolean;
var
   vExcel, vSheet, vWorkBook:variant;
   Row, Col, c, PageNum, i, PageRow:integer;
   s, sTemp:string;
begin
   Result:=False;
   try
     if DataSet.Active then begin
       vExcel:=UnAssigned;
       PageRow:=0;
       try
         vExcel:=CreateOleObject('Excel.Application');
       except
         ShowError('   OLE-. ,     Excel97  .');
         Exit;
       end;
       vExcel.DisplayAlerts:=false;
       vWorkBook:=vExcel.WorkBooks.Add;
       vExcel.Visible:=ShowAsRowsFill;

       PageNum:=1;

       //  
       vSheet:=vWorkBook.WorkSheets[PageNum];

       s:=DataSet.FieldByName(GroupFieldName).asString;
       i:=pos('/', s);
       if i=0 then begin
       end
       else begin
         s[i]:='_';
       end;
       vSheet.Name:=s;

       Row:=FirstRow;
       Col:=FirstCol;
       vSheet.Rows[Row].Font.Bold:=true;
//       vSheet.Rows[Row].HorizontalAlignment:=$FFFFEFF4;
       vSheet.Rows[Row].HorizontalAlignment:=3;
       for c:=0 to DataSet.FieldCount-1 do begin

         if DataSet.Fields[c].Visible then begin
           vSheet.Cells[Row,Col].Value:=DataSet.Fields[c].DisplayLabel;
           vSheet.Columns[Col].Columnwidth:=DataSet.Fields[c].DisplayWidth;
           case DataSet.Fields[c].DataType of
           ftFloat, ftInteger: begin
             vSheet.Columns[Col].NumberFormat:=TFloatField(DataSet.Fields[c]).DisplayFormat;
           end;
           end;
           inc(Col);
         end;
       end;
       PageNum:=0;

       Col:=FirstCol;
       while not DataSet.EOF do begin
         Inc(PageNum);
         //  
         vSheet:=vWorkBook.WorkSheets[PageNum];
         vSheet.Activate;
         vSheet.Columns.ColumnWidth:=ColumnWidth;

         s:=DataSet.FieldByName(GroupFieldName).asString;
         i:=pos('/', s);
         if i=0 then begin
         end
         else begin
           s[i]:='_';
         end;
         vSheet.Name:=s;

//         vSheet.Rows[Row].HorizontalAlignment:=$FFFFEFF4;
         vSheet.Rows[Row].HorizontalAlignment:=3;

         Row:=FirstRow;
         vSheet.Rows[Row].Font.Bold:=true;
         for Col:=FirstCol to 20 do begin
           vSheet.Cells[Row,Col].Value:=vWorkBook.WorkSheets[1].Cells[Row,Col].Value;
         end;
         Col:=FirstCol;
         Inc(Row);

         s:=DataSet.FieldByName(GroupFieldName).asString;
         PageRow := Row;

         while (s=DataSet.FieldByName(GroupFieldName).asString) and not DataSet.EOF do begin
           Col:=FirstCol;
           for c:=0 to DataSet.FieldCount-1 do begin
             if DataSet.Fields[c].Visible then begin
               ValueFromFieldToCell(DataSet.Fields[c], vSheet.Cells[Row,Col], True, False);
//               vSheet.Cells[Row,Col].Value:=DataSet.Fields[c].asString;
               inc(Col);
             end;
           end;
           vSheet.Rows[Row].Select;
           Inc(Row);
           if Row-PageRow=CountRowsInPage-FirstRow-2 then begin
             Col:=FirstCol;
             for c:=0 to DataSet.FieldCount-1 do begin
               if DataSet.Fields[c].FieldName='ONHAND_OUT' then begin
                 vSheet.Cells[Row,Col].Formula:='=SUM(B'+IntToStr(PageRow)+':B'+IntToStr(Row-1)+')';
                 vSheet.Cells[Row,Col-1].Value:=' :';
                 vSheet.Cells[Row,Col-1].Font.Bold:=true;
                 vSheet.Cells[Row,Col-1].HorizontalAlignment:=$FFFFEFF4;


                 sTemp:=vSheet.Cells[Row,Col].Value;
                 i:=pos(',', sTemp);
                 if i<>0 then sTemp[i]:='.';
//                 vSheet.Cells[Row+1,FirstCol].Value:=Speller(StrToFloat(sTemp)); !!!
               end;
               if DataSet.Fields[c].Visible then inc(Col);
             end;
             Row:=Row+3;
             vSheet.Rows[Row].Font.Bold:=true;
             vSheet.Rows[Row].HorizontalAlignment:=$FFFFEFF4;
             for Col:=FirstCol to 20 do begin
               vSheet.Cells[Row,Col].Value:=vWorkBook.WorkSheets[1].Cells[FirstRow,Col].Value;
             end;
             inc(Row);
             PageRow:=Row;
           end;
           DataSet.Next;
         end;

         Col:=FirstCol;
         for c:=0 to DataSet.FieldCount-1 do begin
           if DataSet.Fields[c].FieldName='ONHAND_OUT' then begin
             vSheet.Cells[Row,Col].Formula:='=SUM(B'+IntToStr(PageRow)+':B'+IntToStr(Row-1)+')';
             vSheet.Cells[Row,Col-1].Value:=' :';
             vSheet.Cells[Row,Col-1].Font.Bold:=true;
             vSheet.Cells[Row,Col-1].HorizontalAlignment:=$FFFFEFF4;

             sTemp:=vSheet.Cells[Row,Col].Value;
             i:=pos(',', sTemp);
             if i<>0 then sTemp[i]:='.';
//             vSheet.Cells[Row+1,FirstCol].Value:=Speller(StrToFloat(sTemp)); !!!
           end;
           if DataSet.Fields[c].Visible then inc(Col);
         end;

       end;
//       vExcel:=UnAssigned;
       if not vExcel.Visible then vExcel.Visible:=True;
       Result:=True;
     end
     else begin
       Exit;
     end;
   except
     ShowError('   Excel. ');
   end;
end;

end.
